package main

import (
	"fmt"
	"runtime"
	"sync"
)

func main() {
	var group sync.WaitGroup
	m := 2
	// 声明计数器个数
	group.Add(m)

	for i := 0; i < m; i++ {
		go func(name string, group *sync.WaitGroup) {
			for i := 0; i < 3; i++ {
				fmt.Println(name, ":", i)
				runtime.Gosched() // yields the processor, allowing other goroutines to run
			}
			group.Done()
		}(fmt.Sprintf("no%d", i), &group)
	}
	group.Wait()
}

/*
Output:
no1 : 0
no0 : 0
no1 : 1
no0 : 1
no1 : 2
no0 : 2
*/
